#include "gesture-extension-manager-private.h"
#include "gesture-extensions/slide-gesture.h"

#include <QDebug>

namespace UkuiGestureExtension {

GestureExtensionManagerPrivate::GestureExtensionManagerPrivate(QObject* parent) : QObject(parent)
{
    registerGestureExtension();
}

GestureExtensionManagerPrivate::~GestureExtensionManagerPrivate()
{
//    qDebug() << "~GestureExtensionManagerPrivate";
    if (m_extensions.isEmpty())
        return;
    for (auto begin = m_extensions.begin(); begin != m_extensions.end(); ++begin) {
        delete *begin;
    }
}

void GestureExtensionManagerPrivate::registerWidget(QWidget* widget)
{
    for (auto begin = m_extensions.begin(); begin != m_extensions.end(); ++begin) {
        if ((*begin)->isWidgetUseExtension(widget))
            (*begin)->registerWidget(widget);
    }
}

void GestureExtensionManagerPrivate::unregisterWidget(QWidget* widget)
{
    for (auto begin = m_extensions.begin(); begin != m_extensions.end(); ++begin) {
        (*begin)->unregisterWidget(widget);
    }
}

void GestureExtensionManagerPrivate::registerGestureExtension()
{
    SlideGesture* slideListView = new SlideGesture(this);
    m_extensions.push_back(slideListView);

    //! \todo load extension from extension dir
}

} // namespace
