#ifndef GESTUREEXTENSIONMANAGERPRIVATE_H
#define GESTUREEXTENSIONMANAGERPRIVATE_H

#include <QObject>
#include <QVector>

namespace UkuiGestureExtension {

class GestureExtension;
class GestureExtensionManagerPrivate : public QObject
{
    Q_OBJECT
public:
    explicit GestureExtensionManagerPrivate(QObject *parent = nullptr);
    ~GestureExtensionManagerPrivate();

    /*!
     * \brief registerWidget
     * \details register the widget to all extension
    */
    void registerWidget(QWidget* widget);
    /*!
     * \brief unregisterWidget
     * \details unregister the widget to all extension
    */
    void unregisterWidget(QWidget* widget);

    void registerGestureExtension();

private:

    QVector<GestureExtension*> m_extensions;

};

} // namespace

#endif // GESTUREEXTENSIONMANAGERPRIVATE_H
