#ifndef SLIDEGESTURE_H
#define SLIDEGESTURE_H

#include "gesture-extension.h"

#include <QObject>
#include <QTimer>
#include <QPoint>

#include <QDebug>

namespace UkuiGestureExtension {

class SlideGesture : public QObject, public GestureExtension
{
    Q_OBJECT
public:
    explicit SlideGesture(QObject* parent = nullptr);
//    ~SlideListViewGesture() { qDebug() << "~SlideListViewGesture"; }
    void registerWidget(QWidget* widget);
    void unregisterWidget(QWidget* widget);

    const QString extensionId() override { return "SlideListViewGesture"; }

protected:
    bool eventFilter(QObject* watched, QEvent* event);

private:
    QPoint m_press_pos;
    QTimer* m_touch_slide_timer;

    bool isWidgetUseExtension(QWidget* widget);

    /*! \note
     *  if widget hide scroll bar but want touch scroll, set property like
     *  widget->setProperty("slideNoScrollBar", true);
    */
    bool isWidgetSlideNoScrollBar(QWidget* widget);
};

} // namespace

#endif // SLIDEGESTURE_H
